/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "@wordpress/api-fetch":
/***/ (function(module) {
module.exports = window["wp"]["apiFetch"];
/***/ }),

/***/ "@wordpress/block-editor":
/***/ (function(module) {
module.exports = window["wp"]["blockEditor"];
/***/ }),

/***/ "@wordpress/blocks":
/***/ (function(module) {
module.exports = window["wp"]["blocks"];
/***/ }),

/***/ "@wordpress/components":
/***/ (function(module) {
module.exports = window["wp"]["components"];
/***/ }),

/***/ "@wordpress/element":
/***/ (function(module) {
module.exports = window["wp"]["element"];
/***/ }),

/***/ "@wordpress/i18n":
/***/ (function(module) {
module.exports = window["wp"]["i18n"];
/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_blocks__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/blocks */ "@wordpress/blocks");
/* harmony import */ var _wordpress_blocks__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_blocks__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wordpress/i18n */ "@wordpress/i18n");
/* harmony import */ var _wordpress_i18n__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _wordpress_block_editor__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @wordpress/block-editor */ "@wordpress/block-editor");
/* harmony import */ var _wordpress_block_editor__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @wordpress/api-fetch */ "@wordpress/api-fetch");
/* harmony import */ var _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_5__);


const blockIcon = {
  src: 'admin-links',
  foreground: '#007cba'
};


const Edit = props => {
  const {
    attributes,
    setAttributes
  } = props;
  const {
    url,
    cardData
  } = attributes;
  const [isLoading, setIsLoading] = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [error, setError] = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useState)(null);

  // URLが変更されたら情報を取得
  (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
    if (url && !cardData) {
      fetchCardData();
    }
  }, [url]);


  const fetchCardData = async () => {
    if (!url) return;
    setIsLoading(true);
    setError(null);
    try {
      const data = await _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_5___default()({
        path: `/blog-card-block/v1/url-data?url=${encodeURIComponent(url)}`
      });
      if (data && data.title) {
        setAttributes({
          cardData: data
        });
      } else {
        setError((0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('リンク情報を取得できませんでした。', 'blog-card-block'));
      }
    } catch (err) {
      setError((0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('リンク情報を取得できませんでした。', 'blog-card-block'));
    } finally {
      setIsLoading(false);
    }
  };


  const renderPlaceholder = () => {
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_4__.Placeholder, {
      icon: blockIcon.src,
      label: (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('ブログカード', 'blog-card-block'),
      instructions: (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('URLを入力してブログカードを表示します。', 'blog-card-block')
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-url-input"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_3__.URLInput, {
      value: url,
      onChange: value => {
        setAttributes({
          url: value,
          cardData: null
        });
      },
      placeholder: (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('URLを入力', 'blog-card-block')
    }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_4__.Button, {
      isPrimary: true,
      onClick: fetchCardData,
      disabled: !url
    }, (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('取得', 'blog-card-block'))), error && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("p", {
      className: "bcb-error-message"
    }, error));
  };


  const renderSimplifiedCard = () => {
    if (!cardData) return null;
    const { title, site_name } = cardData;
    
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-simple-card"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-simple-card-content"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-simple-card-title"
    }, title), site_name && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-simple-card-site"
    }, site_name), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-simple-card-url"
    }, url)), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-simple-card-actions"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_4__.Button, {
      isSecondary: true,
      onClick: () => {
        setAttributes({
          url: '',
          cardData: null
        });
      }
    }, (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('URLを変更', 'blog-card-block'))));
  };

  if (isLoading) {
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "bcb-loading"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_4__.Spinner, null), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("p", null, (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('リンク情報を取得中...', 'blog-card-block')));
  }

  return !url || !cardData ? renderPlaceholder() : renderSimplifiedCard();
};


const Save = props => {
  const { attributes } = props;
  const { url } = attributes;

  return url ? (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "bcb-card-container"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("a", {
    className: "bcb-card-link",
    href: url,
    target: "_blank",
    rel: "noopener noreferrer"
  })) : null;
};


(0,_wordpress_blocks__WEBPACK_IMPORTED_MODULE_1__.registerBlockType)('blog-card-block/blog-card', {
  apiVersion: 2,
  title: (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('ブログカード', 'blog-card-block'),
  description: (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('リンク先の情報を取得し、ブログカードとして表示します。', 'blog-card-block'),
  icon: blockIcon,
  category: 'widgets',
  keywords: [(0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('ブログカード', 'blog-card-block'), (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('リンクカード', 'blog-card-block'), (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('リンク', 'blog-card-block'), (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_2__.__)('カード', 'blog-card-block'), 'blog card', 'link card'],
  supports: {
    html: false
  },
  attributes: {
    url: {
      type: 'string',
      default: ''
    },
    cardData: {
      type: 'object',
      default: null
    }
  },
  edit: Edit,
  save: Save
});
}();
/******/ })();